var ledArray=[];
var startupTmr=0;
var ampMode=0;
var alive=0;
var popUpWnd=null;
var popUpWndActive=false ;
var popUpType=0;
var xmlhttpRecurr=null;
//var lastSelAntenna='z';
var urlPrex='' ;
var uniqueID=0;
var disablePage=0;
var scriptURL="http://www.remoterig.com/1216H/kpa500" ;
var gotReply=1;
var opStby=0;
var ajaxTimeout=0;

function getXMLHttp()
{
	if (window.XMLHttpRequest)
		// code for IE7+, Firefox, Chrome, Opera, Safari
		xmlhttp2=new XMLHttpRequest();
	else
		// code for IE6, IE5
		xmlhttp2=new ActiveXObject("Microsoft.XMLHTTP");

	return xmlhttp2 ;
}

function sendCmd(cmd)
{
	var url = urlPrex + "ampcmd?c=" + cmd + new Date().getTime();
	xmlhttp = getXMLHttp() ;
	xmlhttp.open("GET",url,true);
	xmlhttp.send(null);
}

function displayBtnF(e)
{
	sendCmd('G') ;
}

function powerBtnF(e)
{
	sendCmd('J') ;
}

function mainpwrbtnF(e)
{
	// Main power on?
	if ( ledArray[7].mode != 0 )
	{
		// Yes, amp power on?
		if ( ledArray[6].mode != 0 )
		{
			// Yes
			if ( confirm("Amplifer power is on, please use on/off button to turn off power, or click OK to turn main power off anyway" ) )
				sendCmd('B') ;
		}
		else
		{
			if ( confirm("Are you sure you want to turn off main power?" ) )
				sendCmd('B') ;
		}
	}
	else
	{
		if ( confirm("Are you sure you want to turn on main power?" ) )
			sendCmd('A') ;
	}
}

function pwrbtnF(e)
{
	// Main power off?
	if ( ledArray[7].mode == 0 )
		// Yes, then can't power on!
		alert("Main power needs to be on before powering on the amplifier!") ;
	else
	{
		// Yes, amp power on?
		if ( ledArray[6].mode != 0 )
		{
			// Yes, then turn off
			if ( confirm("Are you sure you want to turn off the amplifier?" ) )
				sendCmd('C') ;
		}
		else
		{
			if ( confirm("Are you sure you want to turn on the amplifier?" ) )
				sendCmd('D') ;
		}
	}
}

function opstdbyF(e)
{
	// Main or amplifier power off?
	if ( ledArray[7].mode == 0 || ledArray[6].mode == 0 )
		// Yes, then can't power on!
		alert("Main+amplifier power needs to be on before changing to operate mode!") ;
	// Amplfier must be either in operate eller standby mode
	//else if ( ledArray[4].mode == 0 && ledArray[5].mode == 0 )
	//	alert("Amplifier not in operate/standby mode!") ;
	else
	{	// Operate mode?
		if ( ledArray[4].mode != 0 )
			sendCmd('E') ; // Yes, set standby
		else
			sendCmd('F') ; // No, set operate
	}
}

function bandUpF(e)
{
	sendCmd('K') ;
}

function bandDownF(e)
{
	sendCmd('L') ;
}

function ledHandler(indx)
{
	if (indx<=3)
		return ;

	// Off
	if (ledArray[indx].mode==0)
		document.getElementById(ledArray[indx].id).src=scriptURL+"/img/led2off.png";
	// On
	else if (ledArray[indx].mode==1)
		document.getElementById(ledArray[indx].id).src=scriptURL+"/img/led2on"+ledArray[indx].c+".png";
	// Blink
	else if (ledArray[indx].mode==2)
	{
		if(ledArray[indx].state<7)
		{
			ledArray[indx].state++ ;
			document.getElementById(ledArray[indx].id).src=scriptURL+"/img/led2on"+ledArray[indx].c+".png";
		}
		else if(ledArray[indx].state<14)
		{
			ledArray[indx].state++ ;
			document.getElementById(ledArray[indx].id).src=scriptURL+"/img/led2off.png";
		}
		else
			ledArray[indx].state=0;
	}
	// Flash
	else if (ledArray[indx].mode==3)
	{
		if(ledArray[indx].state<2)
		{
			ledArray[indx].state++ ;
			document.getElementById(ledArray[indx].id).src=scriptURL+"/img/led2on"+ledArray[indx].c+".png";
		}
		else if(ledArray[indx].state<4)
		{
			ledArray[indx].state++ ;
			document.getElementById(ledArray[indx].id).src=scriptURL+"/img/led2off.png";
		}
		else if(ledArray[indx].state<6)
		{
			ledArray[indx].state++ ;
			document.getElementById(ledArray[indx].id).src=scriptURL+"/img/led2on"+ledArray[indx].c+".png";
		}
		else if(ledArray[indx].state<12)
		{
			ledArray[indx].state++ ;
			document.getElementById(ledArray[indx].id).src=scriptURL+"/img/led2off.png";
		}
		else
			ledArray[indx].state=0;
	}
	else
		document.getElementById(ledArray[indx].id).src=scriptURL+"/img/led2off.png";
}

function flashHandler()
{
	for(i=0;i<9;i++)
		ledHandler(i) ;
}

function restartTmr(tid)
{
	if (startupTmr!=0)
		clearTimeout(startupTmr);
	startupTmr=setTimeout(reCurring,tid) ;
}

function pwrLed(led,mode)
{
	if (mode==0)
		document.getElementById("L"+led).src = scriptURL+"/img/ledoff.png";
	else if (mode == 1)
		document.getElementById("L"+led).src = scriptURL+"/img/ledong.png";
	else if (mode == 3)
		document.getElementById("L"+led).src = scriptURL+"/img/ledony.png";
	else if (mode == 4)
		document.getElementById("L"+led).src = scriptURL+"/img/ledono.png";
	else
		document.getElementById("L"+led).src = scriptURL+"/img/ledonr.png";
}

function rpwrLed(led,mode)
{
	if (mode==0)
		document.getElementById("LR"+led).src = scriptURL+"/img/ledoff.png";
	else if (mode == 1)
		document.getElementById("LR"+led).src = scriptURL+"/img/ledong.png";
	else if (mode == 3)
		document.getElementById("LR"+led).src = scriptURL+"/img/ledony.png";
	else if (mode == 4)
		document.getElementById("LR"+led).src = scriptURL+"/img/ledono.png";
	else
		document.getElementById("LR"+led).src = scriptURL+"/img/ledonr.png";
}

function setPwrTxt(id, txt)
{
	var o=document.getElementById(id) ;
	if (o != null)
		o.innerHTML=txt;
}

function setPos(id,tp,lt,ig)
{
	var o=document.getElementById(id) ;
	if (o == null)
		return null ;
	o.style.top=tp+30;
	o.style.left=lt-25;
	if ( typeof ig != "undefined" )
		o.src = ig ;

	return o;
}

function sendAntCmd()
{
	for(i=0;i<=9;i++)
	{
		if ( document.getElementById("ant"+i).selected=="selected" )
			alert(i);
	}
}

function onExpertStartUp(dbg)
{
/*
	urlPrex='';
	if ( typeof dbg != "undefined" )
		if (dbg=='debug' )
			urlPrex='http://192.168.136.220/' ;
*/
}

function setButtonPos(id,tp,lt,ig,dis)
{
	var o=document.getElementById(id) ;
	if (o == null)
		return null ;
	o.style.top=tp;
	o.style.left=lt;
	if ( typeof ig != "undefined" )
		o.innerHTML='<img src="'+ig+'">';
	if ( typeof dis != "undefined" )
		o.disabled=dis;

	return o;
}

function addOption(sel,opt)
{
	try
	{
		// for IE earlier than version 9
		sel.add(opt,sel.options[null]);
	}
	catch (e)
	{
		sel.add(opt,null);
	}
}

function startUp(sURL,dbg)
{
	var x=50; 
	var o;

	uniqueID=new Date().getTime(); 

	urlPrex='';
	if ( typeof dbg != "undefined" )
		if (dbg=='debug' )
			urlPrex='http://192.168.136.220/' ;

	if ( typeof sURL != "undefined" )
		scriptURL = sURL ;

	var bandmenu=document.getElementById("bandsel");
	if ( bandmenu != null )
	{
		var opt = document.createElement("option");
		opt.value = "0";
		opt.text  = "160m";
		addOption(bandmenu,opt);

		opt = document.createElement("option");
		opt.value = "1";
		opt.text  = "80m";
		addOption(bandmenu,opt);

		opt = document.createElement("option");
		opt.value = "2";
		opt.text  = "60m";
		addOption(bandmenu,opt);

		opt = document.createElement("option");
		opt.value = "3";
		opt.text  = "40m";
		addOption(bandmenu,opt);

		opt = document.createElement("option");
		opt.value = "4";
		opt.text  = "30m";
		addOption(bandmenu,opt);

		opt = document.createElement("option");
		opt.value = "5";
		opt.text  = "20m";
		addOption(bandmenu,opt);

		opt = document.createElement("option");
		opt.value = "6";
		opt.text  = "17m";
		addOption(bandmenu,opt);

		opt = document.createElement("option");
		opt.value = "7";
		opt.text  = "15m";
		addOption(bandmenu,opt);

		opt = document.createElement("option");
		opt.value = "8";
		opt.text  = "12m";
		addOption(bandmenu,opt);

		opt = document.createElement("option");
		opt.value = "9";
		opt.text  = "10m";
		addOption(bandmenu,opt);

		opt = document.createElement("option");
		opt.value = "10";
		opt.text  = "6m";
		addOption(bandmenu,opt);

		bandmenu.onchange=function()
		{	
			var chosenoption=this.options[this.selectedIndex]
			//alert(chosenoption.value) ;
			if ( this.selectedIndex>0)
			{
				sendCmd("M"+chosenoption.value+"X");
				this.selectedIndex=0;
			}
		}
	}

	xmlhttpRecurr = getXMLHttp() ;

	// 0-3=Not in use
	ledArray[0] = {id:"LE1", mode:0, state:0, c:"r"};
	ledArray[1] = {id:"LE2", mode:0, state:0, c:"y"};
	ledArray[2] = {id:"LE3", mode:0, state:0, c:"y"};
	ledArray[3] = {id:"LE4", mode:0, state:0, c:"y"};

	ledArray[4] = {id:"LE5", mode:0, state:0, c:"g"};
	ledArray[5] = {id:"LE6", mode:0, state:0, c:"y"};
	ledArray[6] = {id:"LE7", mode:0, state:0, c:"r"};
	ledArray[7] = {id:"LE8", mode:0, state:0, c:"r"};
	ledArray[8] = {id:"LE9", mode:0, state:0, c:"g"};

	setPos("header",0,50);
	setPos("fpwr",27,50);
	setPos("LET1",170,77);
	setPos("LET2",194,77);
	//setPos("LET3",85,125);
	//setPos("LET4",85,160);
	setPos("rpwr",85,226);

	setPos("BS",200,53);
	setPos("BSV",200,87);
	setPos("bandsel",220,50);

	for(i=1;i<=16;i++)
	{
		setPos("L"+i,50,x,scriptURL+"/img/ledoff.png");
		setPos("TL"+i,60,x);
		x=x+22;
	}

	x=50+8*22;
	for(i=1;i<=8;i++)
	{
		setPos("LR"+i,110,x,scriptURL+"/img/ledoff.png");
		setPos("TR"+i,120,x);
		x=x+22;
	}

	//setPos("LE1",170,55,scriptURL+"/img/led2off.png");
	//setPos("LE2",193,55,scriptURL+"/img/led2off.png");
	//setPos("LE3",107,128,scriptURL+"/img/led2off.png");
	//setPos("LE4",107,165,scriptURL+"/img/led2off.png");
	setPos("LET5",170,284);
	setPos("LE5",170,263,scriptURL+"/img/led2off.png");
	setPos("LET6",189,284);
	setPos("LE6",193,263,scriptURL+"/img/led2off.png");
	setPos("LET7",189,380);
	setPos("LE7",188,358,scriptURL+"/img/led2off.png");

	setPos("mainpwrbtn",215,180);
	setPos("LE8",188,200,scriptURL+"/img/led2off.png");

	//o=setPos("readparams",215,120);
	//if(o!=null)
	//	o.disabled="disabled";

	o=setPos("opstdby",215,260);	// 190
	if(o!=null)
		o.disabled="disabled";

	//o=setPos("autotune",215,50);
	//if(o!=null)
	//	o.disabled="disabled";

	o=setPos("pwrbtn",215,340);
	if(o!=null)
		o.disabled="disabled";

	setPos("T1",100,53);
	setPos("TV",120,53);
	setPos("T2",120,53+17);

	setPos("LE9",15,380,scriptURL+"/img/led2off.png");

	setPos("status",17,120);

	//setPos("currFqTxt",127,50);
	//setPos("currFq",147,50);


	window.setInterval("flashHandler()", 50) ;

	reCurring();
}

function reCurring()
{
	var o;

	xmlhttpRecurr.onreadystatechange=function()
	{
		if (xmlhttpRecurr.readyState==4 && xmlhttpRecurr.status==200)
		{
			var str = xmlhttpRecurr.responseText;
			var dta = str.split("|") ;
			var move = 0 ;

			for(i=1;i<=16;i++)
				pwrLed(i,0) ;

			for(i=1;i<=8;i++)
				rpwrLed(i,0) ;

			// 1:  Forward pwr leds (0-16)
			if (dta.length >= 1)
			{
				var leds=parseInt(dta[0],10);
				for(i=1;i<=16;i++)
				{
					// On?
					if(leds>=i)
					{
						// Yes, red?
						if(i>=15)
							pwrLed(i,2);
						// Yellow?
						else if(i>=13)
							pwrLed(i,3);
						else
							// green
							pwrLed(i,1);
					}
					else
						break ;
				}
			} 

			// 2:  Reflected pwr leds (0-8)
			if ( dta.length >= 2 )
			{
				var leds=parseInt(dta[1],10);
				for(i=1;i<=8;i++)
				{
					// On?
					if(leds>=i)
					{
						// Yes, red?
						if(i>=7)
							rpwrLed(i,2);
						// Yellow?
						else if(i>=5)
							rpwrLed(i,3);
						else
							// green
							rpwrLed(i,1);
					}
					else
						break ;
				}
			}

			// 3:  Led1 = Full pwr
			if ( dta.length >= 3 )
				ledArray[0].mode=parseInt(dta[2],10);

			// 4:  Led2 = Half pwf
			if ( dta.length >= 4 )
				ledArray[1].mode=parseInt(dta[3],10);

			// 5:  Led3 = Not in use
			if ( dta.length >= 5 )
				ledArray[2].mode=parseInt(dta[4],10);

			// 6:  Led4 = Not in use
			if ( dta.length >= 6 )
				ledArray[3].mode=parseInt(dta[5],10);

			// 7:  Led5 = Operate
			if ( dta.length >= 7 )
				ledArray[4].mode=parseInt(dta[6],10);

			// 8:  Led6 = Standby
			if ( dta.length >= 8 )
			{
				ledArray[5].mode=parseInt(dta[7],10);

				// Going to Op now?
				if( opStby!=1 )
				{
					if ( ledArray[4].mode!=0 && ledArray[5].mode==0 )
					{
						document.getElementById("fpwr").innerHTML="Forward PWR, W" ;
						setPwrTxt( "TL1", "100") ;
						setPwrTxt( "TL2", "125") ;
						setPwrTxt( "TL3", "150") ;
						setPwrTxt( "TL4", "175") ;
						setPwrTxt( "TL5", "200") ;
						setPwrTxt( "TL6", "225") ;
						setPwrTxt( "TL7", "250") ;
						setPwrTxt( "TL8", "300") ;
						setPwrTxt( "TL9", "350") ;
						setPwrTxt( "TL10", "400") ;
						setPwrTxt( "TL11", "450") ;
						setPwrTxt( "TL12", "500") ;
						setPwrTxt( "TL13", "550") ;
						setPwrTxt( "TL14", "600") ;
						setPwrTxt( "TL15", "650") ;
						setPwrTxt( "TL16", "700") ;
						opStby=1 ;
					}
				}

				// Going to Stby now?
				if( opStby!=2 )
				{
					if ( ledArray[4].mode==0 && ledArray[5].mode!=0 )
					{
						document.getElementById("fpwr").innerHTML="Stby Drive PWR, W" ;
						setPwrTxt( "TL1", "2") ;
						setPwrTxt( "TL2", "5") ;
						setPwrTxt( "TL3", "10") ;
						setPwrTxt( "TL4", "15") ;
						setPwrTxt( "TL5", "20") ;
						setPwrTxt( "TL6", "25") ;
						setPwrTxt( "TL7", "30") ;
						setPwrTxt( "TL8", "40") ;
						setPwrTxt( "TL9", "50") ;
						setPwrTxt( "TL10", "60") ;
						setPwrTxt( "TL11", "70") ;
						setPwrTxt( "TL12", "80") ;
						setPwrTxt( "TL13", "90") ;
						setPwrTxt( "TL14", "100") ;
						setPwrTxt( "TL15", "110") ;
						setPwrTxt( "TL16", "120") ;
						opStby=2 ;
					}
				}
			}

			// 9:  Led7 = Amplifier Power
			if ( dta.length >= 9 )
			{
				ledArray[6].mode=parseInt(dta[8],10);

				if (ledArray[6].mode!=0)
					dis="" ;
				else
					dis="disabled" ;

				o=document.getElementById("opstdby");
				o.disabled=dis;
				//o=document.getElementById("readparams");
				//o.disabled=dis;
				o=document.getElementById("bandsel");
				if(o!=null)
					o.disabled=dis;
				//o=document.getElementById("autotune");
				//if(o!=null)
				//	o.disabled=dis;
			}

			// 10: Led8 = Main Power
			if ( dta.length >= 10 )
			{
				ledArray[7].mode=parseInt(dta[9],10);
				o=document.getElementById("pwrbtn");
				if (ledArray[7].mode!=0)
					o.disabled="" ;
				else
					o.disabled="disabled" ;
			}

			// 11: Status+Meddelande
			if ( dta.length >= 11 )
			{
				ampMode=parseInt(dta[10].substr(0,1));
				document.getElementById("status").innerHTML=dta[10].substr(1) ;
			}

			// 12: Lufttemp i grader C. (0xFF=Okand)
			if ( dta.length >= 12 )
			{
				if(parseInt(dta[11],10)==0xFF)
					document.getElementById("TV").innerHTML='--';
				else
					document.getElementById("TV").innerHTML=dta[11] ;
			}

			// 13: Band segment value, for ex: "07100-07200 A2 DEF"
			if ( dta.length >= 13 )
				document.getElementById("BSV").innerHTML=dta[12] ;

			// 14: Online mode,2=ingen kontakt med amplifier,1=kontakt med amplifier
			if ( dta.length >= 14 )
			{
				ledArray[8].mode=parseInt(dta[13],10);
				alive=20;	// 20=10 sek
				gotReply=1;
			}

			// 15: Forward pwr, max led
			if ( dta.length >= 15 )
			{
				var led=parseInt(dta[14],10);
				if (led > 0)
					pwrLed(led,4); 
			}

			// 16: Reflected pwr, max led
			if ( dta.length >= 16 )
			{
				var led=parseInt(dta[15],10);
				if (led > 0)
					rpwrLed(led,4); 
			}

			// 17: Auto tune marker position
			if ( dta.length >= 17 )
			{
				var pos=parseInt(dta[16],10);

				for(i=1;i<=12;i++)
				{
					if (popUpType == 2 && popUpWnd != null && !popUpWnd.closed)
					{
						o=popUpWnd.document.getElementById("L"+i) ;
						if (o != null)
						{
							if ( pos == i )
							{
								if (pos >= 5 && pos <= 9)
									o.src = scriptURL+"/img/ledong.png";
								else
									o.src = scriptURL+"/img/ledonr.png";
							}
							else
								o.src = scriptURL+"/img/ledoff.png";
						}
					}
				}
			}

			// 18: Auto tune-meddelande
			if ( dta.length >= 18 )
			{
				if (dta[17].length > 0)
				{
					if (popUpType == 2 && popUpWnd != null && !popUpWnd.closed)
					{
						o=popUpWnd.document.getElementById("msg") ;
						if (o != null )
						{
							o.innerHTML += dta[17] ;
							o.innerHTML += '<br>'  ;
						}
					}
				}
			}

			// 19: Disable hmtning
			if ( dta.length >= 19 )
				disablePage=parseInt(dta[18],10);

			// 20: Temperaturenhet
			if ( dta.length >= 20 )
				document.getElementById("T2").innerHTML=dta[19];

			// 21: Aktuell frekvens
			//if ( dta.length >= 21 )
			//	document.getElementById("currFq").innerHTML=dta[20];

			// 22: Expert-varning/larm-historia
			if ( dta.length >= 22 )
			{
				if (parseInt(dta[21],10) != 0)
				{
					if (ledArray[8].mode==1 && popUpWnd == null)
					{
						popUpType=2;
						popUpWnd=window.open("kpa500popup", "popUpWnd", "location=1,status=0,scrollbars=0,width=350,height=150,location=0");

						// Ge lite tid innan statusuppdatering av sidan s popup-fnstret r redo
						restartTmr(1000);
					}
				}
			}

			//restartTmr(500);

			return ;
		}
	}

	// Fortfarande kontakt med switchen?
	if ( alive )
	{
		if( --alive == 0 )
			ledArray[8].mode=0; // Nej
	}
	else
	{
		// Ingen kontakt
		for(i=1;i<=16;i++)
			pwrLed(i,0) ;

		for(i=1;i<=8;i++)
			rpwrLed(i,0) ;

		for(i=0;i<=8;i++)
			ledArray[i].mode=0;

		//document.getElementById("currFq").innerHTML='---';
	}

	if (popUpWnd!=null)
	{
		if (popUpWnd.closed)
		{
			popUpWnd=null;
			popUpWndActive=false;
			popUpType=0;
		}
	}

	// Ny hmtning tillten?		
	if (disablePage == 0)
	{
		if ( gotReply )
		{
			var url = urlPrex + "ampdta.srv?d=N" + uniqueID + "D" + new Date().getTime();
			xmlhttpRecurr.open("GET",url,true);
			xmlhttpRecurr.send();
			ajaxTimeout=15000/500 ;	// 15 secs timeout

			gotReply = 0;
		}
		else
		{
			if ( ajaxTimeout )
			{
				if ( --ajaxTimeout == 0 )
				{
					// Makes another ajax reload happen
					gotReply = 1 ; 
					// Abort any pending request
					if ( xmlhttpRecurr != null )
						xmlhttpRecurr.abort() ;
				}
			}
		}
	}
	else
		document.getElementById("status").innerHTML="<b>Page offline!</b>" ;

	restartTmr(500);
}
